import greenfoot.*; 
import java.util.Timer;
import java.util.TimerTask;

/**
 * Write a description of class Mundo here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Mundo extends World
{
   
    private static final GreenfootImage bgImage = new GreenfootImage("carretera.gif");
    private int scrollSpeed;
    private GreenfootImage imagenG;
    private GreenfootImage scrollingImage;
    private int scrollPosition = 0;
    private boolean pause;
    private needle n = new needle();
    private  Fugitive f=new Fugitive(n);
    private  Poli p=new Poli(f);
    private int dano;
    private int ganaste;
    private int score;
    private int num;
    private int vel;
    private int cont;
    private int numbalas;
    private int nivel;
     
    /**
     * Constructor for objects of class Mundo.
     * 
     */
    public Mundo()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(1000, 600, 1);
        
        menu();
        numbalas=5;
        dano=100;
        score=0;
        num=500;
        nivel=0;
        scrollSpeed=1;
        pause=false;
         imagenG=new GreenfootImage("ayuda.gif");
        setPaintOrder(Poste.class,Fugitive.class,Smoke.class,Obstaculos.class,Rai.class);
         
    }
    
    
    
    
     /**
     * metodo de actua
     */
    public void act()
    { 
      cont++;
       ChecaVida();
       scroll();
      
              
           
    }
    
    /**
     * metodo en el cual se realiza el scroll del mundo por medio de dos variables 
     * velocidad de scroll y la posicion de la imgagen ademas de insertar los objetos que van 
     * apareciendo en el mundo
     */
    public void scroll()
    {
      if(pause)
        {
        if (scrollSpeed!=0)
        {
            
            if(scrollSpeed > 0 && scrollPosition <= 0) {
               scrollPosition = getWidth();
            }
            if(scrollSpeed < 0 && scrollPosition >= getWidth()) {
               scrollPosition = 0;
            }
            scrollPosition -= scrollSpeed;
            paint(scrollPosition);
            chanceToRai();
            changeTronco();
            changePoste();
            changeGas();
            changeToCargador();
        }
        chanceToVehicle();
       
       }
    }
    
    /**
     *  metodo en el que se checa si gano o perdio el jugador ademas de hacer diferentes acciones 
     *  dependiendo del caso en el que se encuentre el jugador
     */
    public void ChecaVida()
    {
        
        if(this.dameDano()<=0)
        {
           this.removeObjects(this.getObjects(null));
           setBackground("preso.png");
           addObject(new Retorno(),880,450);
           pause=false;
            cambiaDano(10);
        }
        else
           if(this.dameGanaste()==1)
           {
               
                
                if(nivel==6)
                  {
                  
                   this.removeObjects(this.getObjects(null));
                   addObject(new Retorno(),880,550);
                   setBackground("ganaste.png");
                     pause=  false;
                   nivel=0;
                  
                   }
                   else
                   {
                
                  if(nivel!=0)
                  {
                  addObject(new Poli(f),0,400);
                  this.cambiaGanaste(0);
                   Greenfoot.playSound("sirena.wav");
                  if( num-100>=100)
                  {
                 cambianum(damenum()-100);
                  }
                  else
                  num=50;
                   }
                   }        
        }
    }
  
    /**
     * metodo en el cual se insertan los objetos que lleva el menu del juego
     */
    public void menu()
    {
        addObject(new Menu(),500,300);
        addObject(new Play(),500,530);
        addObject(new Ayuda(),815,530);
        addObject(new Credits(),190,530);
    }
  
    /**
     * Pintura de la imagen de desplazamiento en la posición dada y asegúrese de que el resto de
     * el fondo también está pintado con la misma imagen.
     */
    private void paint(int position)
    {
        GreenfootImage bg = getBackground();
        bg.drawImage(scrollingImage, position, 0);
        bg.drawImage(scrollingImage, position - scrollingImage.getWidth(), 0);
    }
 
    /**
     * Devuelve una imagen con las dimensiones dadas.
     */
    private GreenfootImage getScrollingImage(int width, int height)
    {
        GreenfootImage image = new GreenfootImage(width, height);
        for(int x = 0; x < width; x += bgImage.getWidth()) {
            for(int y = 0; y < height; y += bgImage.getHeight()) {
                image.drawImage(bgImage, x, y);
            }
        }
        return image;
    } 
    
    /**
     * metodo en el cual se sabe si esta en pause el juego
     */
      public boolean getPause()
    {
       return pause;
    }
    
   
    /**
     * metodo que se utiliza para cambiar objetos de tipo Obstaculo 
     * y que vallan apareciendo en el mundo aleatoriamente en un rango de cordenadas
     */
     public void chanceToVehicle()
    {
       if(Greenfoot.getRandomNumber(num)<1)
       {
          addObject(new Obstaculos(f),999,  Greenfoot.getRandomNumber(210)+260);
       }
    }
     /**
     * metodo que se utiliza para cambiar objetos de tipo Gasolina 
     * y que vallan apareciendo en el mundo aleatoriamente en un rango de cordenadas
     */
      public void changeGas()
    {
       if(Greenfoot.getRandomNumber(800)<1)
       {
          addObject(new Gas(),999,  Greenfoot.getRandomNumber(210)+260);
       }
    }
    
    /**
     * metodo en el cual se inicia el juego con los objetos iniciales
     */
    public void ecenario()
    {
        pause=true;
        GreenfootImage background = new GreenfootImage(2000, 600);
        scrollingImage = getScrollingImage(2000, 600);
        background.drawImage(scrollingImage, 0, 0);
        setBackground(background);
       
        addObject(f, 350, 200);
        addObject(new Medidor(), 65, 545);
        addObject(new Status(),930,540);
        addObject(n , 60 ,550);
        addObject(new Sangre(f),f.getX(),f.getY()-60);
        addObject(new CuadroBala(),200,20);
        addObject(new MedidorBala(),215,20);
        addObject(new Cuadro(),getWidth()-190,getHeight()-getHeight()+25);
        addObject(new Cuadro(),getWidth()-410,getHeight()-getHeight()+25);
        addObject(new Score("Points: "),getWidth()-175,getHeight()-getHeight()+30);
        addObject(new Clock(), getWidth()-395,getHeight()-getHeight()+35);
        addObject(new BarraD(), 25, 250);
        addObject(new Punto(), 25, 470);
    }
    

    /**
       * metodo que se utiliza para agregar objetos de tipo Ray en el mundo
       * en cordenadas figas
    */ 
    public void chanceToRai()
    {
       if(Greenfoot.getRandomNumber(num)<1)
       {
          addObject(new Rai(),999,460);
       }
    }
      /**
     * metodo que se utiliza para cambiar objetos de tipo Cargador 
     * y que vallan apareciendo en el mundo aleatoriamente en un rango de cordenadas
     */
       public void changeToCargador()
    {
       if(Greenfoot.getRandomNumber(num)<1)
       {
          addObject(new Cargador(),999, Greenfoot.getRandomNumber(210)+260);
       }
    }
    
     /**
       * metodo que se utiliza para agregar objetos de tipo Poste en el mundo
       * en cordenadas figas
       */ 
    public void changePoste()
    {
       if(Greenfoot.getRandomNumber(num)<1)
       {
          addObject(new Poste(),999,170);
       }
    }
    
      /**
       * metodo que se utiliza para agregar objetos de tipo Tronco en el mundo
       * en cordenadas figas
       */ 
      public void changeTronco()
    {
       if(Greenfoot.getRandomNumber(num)<1)
       {
         addObject(new Tronco(),999,  Greenfoot.getRandomNumber(210)+260);
       }
    }
    
    /**
     * regresa el dano
     */
    public int dameDano()
    {
        return dano;
    }
    
    /**
     * cambia el dano
     */
    public void cambiaDano(int v)
    {
        dano=v;
    }
    
    /**
     *regresa la puntuacion
     */
    public int dameScore()
    {
        return score;
    }
    
    /**
     * cambia la puntuacion
     */
    public void cambiaScore(int s)
    {
        score=s;
    }
    /**
     *regresa la si gano
     */
    public int dameGanaste()
    {
        return ganaste;
    }
    
    /**
     *cambia si gano o perdio
     */
    public void cambiaGanaste(int g)
    {
       ganaste=g;
    }
    
    /**
     *cambia la velocidad del scroll
     */
    public void cambiaSpeedScroll(int vs)
    {
       scrollSpeed=vs;
    }
    
    /**
     *regresa la velocidad del scroll
     */
    public int dameSpeedScroll()
    {
        return scrollSpeed;
    }
    
    /**
     *regresa el numero de balas
     */
   public int dameNumbalas()
   {
      return numbalas; 
   }
   
   /**
     *cambia el numero de balas
     */
   public void cambiaNumbalas(int d)
   {
      numbalas=d;
   }
   
   /**
     *cambia numero que se toma como aleatorio
     */
   public void cambianum(int d)
   {
    num=d;
   }
    
   /**
     *regresa el numero que se toma como aleatorio
     */
  public int damenum()
  {
   return num; 
   }
  
   /**
     *cambia el nivel 
     */
  public void cambiaNivel(int n)
  {
  nivel=n;  
  }
  
  /**
     *regresa el nivel actual
     */
  public int dameNivel()
  {
   return nivel; 
   }
   
}
